/*
 * Author: Evan Peterson
 * Cal Poly, CPE-471, Winter 2014
 */

#ifndef MAIN_H
#define MAIN_H

#include <iostream>
#include <GLFW/glfw3.h>
#include <GL/glut.h>

#include "third_party/GLSL_helper.h"
#include "glm/glm.hpp"
#include "glm/gtc/matrix_transform.hpp" //perspective, trans etc
#include "glm/gtc/type_ptr.hpp" //value_ptr

// XInput-mode gamepad mappings.
#define LEFT_X 0
#define LEFT_Y 1
#define RIGHT_X 3
#define RIGHT_Y 4
#define DPAD_X 6
#define DPAD_Y 7
#define A_BTN 0
#define B_BTN 1
#define X_BTN 2
#define Y_BTN 3
#define LB_BTN 4
#define RB_BTN 5
#define BACK_BTN 6
#define START_BTN 7

struct joystick {
   int id;
   int axisCount;
   int buttonCount;
   const float *axes;
   const unsigned char *buttons;
};

extern float g_viewBound;
extern bool g_usingJoystick;
extern int g_doBoost;
extern float g_axisValue;

#endif
