/*
 * Author: Evan Peterson
 * Cal Poly, CPE-471, Winter 2014
 */

#include "tree.h"

static const int g_zPosBase = -100;
static const int g_zPosMax = -300;
static const int g_xGap = 11;
static const int g_xRange = 60;

Tree::Tree(void)
{
   this->trunk = new Model(CYLINDER_MESH);
   this->tier = new Model(CONE_MESH);

   this->curTrans = glm::vec3(0);
   this->init();
}

void Tree::init(void)
{
   int xPos;

   // Place the tree within some range on either side of a gap (x-dimension).
   xPos = rand() % g_xRange;
   if (rand() % 2) {
      this->curTrans.x = g_xGap + xPos;
   }
   else {
      this->curTrans.x = -g_xGap - xPos;
   }

   // Place the tree somewhere in the range: [g_zPosBase, g_zPosMax].
   this->curTrans.z = g_zPosBase - (rand() % (g_zPosMax - g_zPosBase));
}

bool Tree::draw(void)
{
   this->curTrans.z += g_boardVel;

   g_mStack.pushMatrix();
      g_mStack.translate(this->curTrans);
      g_mStack.scale(.5f, 1.f, .5f);
      g_mStack.rotate(-90, iHat); // new basis: (+X, -Z, +Y)

      // Bind model material.
      setMaterial(BARK_MAT);
      // Bind model texture.
      glBindTexture(GL_TEXTURE_2D, BARK_TEX);
      this->trunk->draw();

      g_mStack.pushMatrix();
         // Bind model material.
         setMaterial(PINE_MAT);
         // Bind model texture.
         glBindTexture(GL_TEXTURE_2D, PINE_TEX);

         g_mStack.scale(3.f, 3.f, 3.f);
         g_mStack.translate(glm::vec3(0, 0, .25f));
         this->tier->draw();
         g_mStack.translate(glm::vec3(0, 0, .25f));
         this->tier->draw();
         g_mStack.translate(glm::vec3(0, 0, .25f));
         this->tier->draw();
      g_mStack.popMatrix();

   g_mStack.popMatrix();

   // The model is still on-screen.
   return this->curTrans.z < g_viewBound;
}
