//
// Author: Evan Peterson
// Cal Poly, CPE-471, Winter 2014
//

uniform mat4 uProjMatrix;
uniform mat4 uViewMatrix;
uniform mat4 uModelMatrix;
uniform vec3 uCamPos;

attribute vec2 aTexCoord;
attribute vec3 aPosition;
attribute vec3 aNormal;

varying vec2 vTexCoord;
varying vec3 vNormal;
varying vec3 vEye;
varying vec3 vPosition;

void main() {
   vec4 position;

   /* Model Transform */
   position = uModelMatrix * vec4(aPosition, 1.0);

   /* Lighting */
   vNormal = vec3(uModelMatrix * vec4(aNormal, 0.0)); // Transform the normal
   vPosition = vec3(position);
   vEye = -uCamPos - vPosition;

   /* Texturing */
   vTexCoord = aTexCoord;

   /* Camera and Projection Transforms */
   gl_Position = uProjMatrix * uViewMatrix * position;
}
